#include <stdio.h>

/*
 * Ausgabe einer Integer (zahl) im Binaer-Format
 * mit minimaler Breite (minWidth), d.h. min. Anzahl Stellen
 */
void printBinaer(int zahl, int minWidth) {
	/*
	 * zuerst die vorderen Bits ausgeben,
	 * sofern es solche gibt (zahl > 1) oder
	 * eben mehr Ziffern ausgegeben werden sollen
	 * (minWidth > 1) => fuehrende Nullen!
	 */
	if (zahl > 1 || minWidth > 1)
		/*
		 * letztes Bit wegfallen lassen (zahl >> 1)
		 */
		printBinaer(zahl >> 1 , minWidth-1);
	/*
	 * letztes Bit ausgeben
	 */
	printf("%d", zahl & 1);
}

int main() {
	int a = 17, b = 3;

	printf("a = "); printBinaer(a, 5); puts("");
	printf("b = "); printBinaer(b, 5); puts("");

	/*
	 * bitweises UND (&), ODER (|) und XOR (^)
	 */
	printf("a & b = "); printBinaer(a & b, 5); puts("");
	printf("a | b = "); printBinaer(a | b, 5); puts("");
	printf("a ^ b = "); printBinaer(a ^ b, 5); puts("");

	/*
	 * Bitverschiebung nach rechts (>>) und links (<<)
	 */
	printf("a >> 1 = "); printBinaer(a >> 1, 5); puts("");
	printf("a << 1 = "); printBinaer(a << 1, 5); puts("");

	return 0;
}
